<template lang="pug">
.vc-table-wrapper
	b-table.vc-table(:data="mappedData" v-bind="tableProps" v-on="tableListeners" @click="onClick")
		template(slot-scope="props")
			template(v-for="column in columns")
				b-table-column(:field="column.field" :label="column.label" :width="column.width" :centered="column.centered" :numeric="column.numeric")
					slot(:name="'field_'+(column.key||column.field)" :row="props.row")
						| {{getValue(props.row, column)}}
			template(v-if="props.row.$actions")
				b-table-column.vc-table__action(label="" :width="actionColumnWidth")
					span.vc-table__action-item(v-for="action in props.row.$actions" v-bind="actionGetProps(action)")
						template(v-if="action.disabled")
							span.vc-table__action-link: b-icon(:icon="action.icon")
						template(v-else-if="action.to")
							router-link.vc-table__action-link(@click.native.stop="" :to="action.to")
								b-icon(:icon="action.icon")
						template(v-else-if="action.anchor")
							a.vc-table__action-link(v-bind="action.anchor")
								b-icon(:icon="action.icon")
						template(v-else-if="action.click")
							a.vc-table__action-link(@click.prevent.stop="action.click(props.row)" href="#")
								b-icon(:icon="action.icon")
						template(v-else)
							span.vc-table__action-link: b-icon(:icon="action.icon")
			td.vc-table__null-cell(v-if="rowTo"): vc-table-row-link(:to="rowTo(props.row)")

		template(slot="empty")
			section.section
				.has-text-centered.has-text-grey
					template(v-if="!isLoading") {{emptyText}}
		template(slot="bottom-left")
			slot(name="bottom-left")
	b-loading(:is-full-page="false" :active="isLoading")
</template>
<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { reduce, map, omit } from 'ramda';
import getValue from 'get-value';
import {
	VueComponentBuefyTableColumnFilter,
	VueComponentBuefyTableColumn,
	VueComponentBuefyTableAction,
	VueComponentBuefyTableActionNormalized,
	VueComponentBuefyTableValue,
} from '~/frameworks/buefy/types';
import VcTableRowLink from './TableRowLink';

@Component({
	inheritAttrs: false,
	components: {
		VcTableRowLink,
	},
	props: {
		items: Array,
		columns: Array,
		actions: Array,
		rowTo: Function,
		loading: Boolean,
		emptyText: { type: String, default: 'Nenhum item encontrado' },
	},
})
/**
 * Better table for buefy
 */
export default class VcTable extends Vue {
	items!: any[];
	columns!: VueComponentBuefyTableColumn[];
	actions!: VueComponentBuefyTableAction[];
	rowTo!: (item: any) => any;
	loading!: boolean;
	emptyText!: string;

	/**
	 * Dados já mapeados
	 */
	get mappedData() {
		if (!this.items || this.loading) return [];
		function fieldNormalize<T, K extends keyof T>(obj: T, field: K, item: any): VueComponentBuefyTableValue<T[K]> {
			if (typeof obj[field] === 'function') return (obj[field] as any).call(null, item);
			return obj[field] as any;
		}
		const actionNormalizer = (item: any) => {
			if (!this.actions) return null;
			const mapper = map(
				(action: VueComponentBuefyTableAction): VueComponentBuefyTableActionNormalized => {
					const icon: string = fieldNormalize(action, 'icon', item);
					const color: string | undefined = fieldNormalize(action, 'color', item);
					const isDisabled: boolean | undefined = fieldNormalize(action, 'disabled', item);
					if (isDisabled) {
						return { icon, color, disabled: true };
					}
					return {
						icon,
						color,
						disabled: false,
						click: action.click,
						to: fieldNormalize(action, 'to', item),
						anchor: fieldNormalize(action, 'anchor', item),
					};
				}
			);
			return mapper(this.actions);
		};
		const itemNormalizer = map(
			(item: any): VueComponentBuefyTableActionNormalized => ({
				...item,
				$actions: actionNormalizer(item),
			})
		);
		return itemNormalizer(this.items);
	}

	get isLoading() {
		return this.loading || !this.items;
	}

	/// Get the table props
	get tableProps() {
		const hasClick = !!(this.$listeners.click || this.rowTo);
		return {
			hoverable: hasClick,
			columns: this.tablePropsColumns,
			paginated: true,
			rowClass() {
				return {
					'vc-table__row': true,
					'is-clickable': hasClick,
				};
			},
			...this.$attrs,
		};
	}
	/// Get the table listeners
	get tableListeners() {
		return omit(['click'], this.$listeners);
	}
	get tablePropsColumns() {
		if (this.items && this.items.length > 0) return void 0;
		return this.columns;
	}

	/// Pega a largura das colunas
	get actionColumnWidth() {
		return this.actions.length * 34 + 16;
	}

	/**
	 * Pega as propriedades da ação
	 */
	actionGetProps(action) {
		const styles: any = {};
		const classes: any = [];
		if (action.color) {
			if (action.color.substr(0, 3) === 'is-') {
				classes.push(action.color);
			} else {
				styles.color = action.color;
			}
		}
		if (action.disabled) classes.push('is-disabled');
		else classes.push('is-enabled');
		return {
			class: classes,
			style: styles,
		};
	}

	// Emite o evento de click
	onClick(item) {
		this.$emit('click', item);
		if (this.rowTo) {
			const rowTo = this.rowTo(item);
			if (rowTo && !rowTo.href) this.$router.push(rowTo);
		}
	}

	// Pega o valor da row
	getValue(row: any, column: VueComponentBuefyTableColumn) {
		let value = getValue(row, column.field);
		value = applyFilter(value, column.filter, column);
		return value;
	}
}

function applyFilter(
	value: any,
	filter?: VueComponentBuefyTableColumnFilter | VueComponentBuefyTableColumnFilter[],
	column?: VueComponentBuefyTableColumn
) {
	if (!filter) {
		return value;
	} else if (Array.isArray(filter)) {
		return reduce((v, f) => applyFilter(v, f, column), value, filter);
	} else if (typeof filter === 'function') {
		return filter(value);
	}
	const vueFilter = Vue.filter(filter);
	if (!vueFilter) {
		console.error(`Invalid filter on table "${filter}"` + (column ? ` for column "${column.label}" ` : ''));
		return value;
	}
	return vueFilter(value);
}
</script>
<style lang="scss" scoped>
.vc-table-wrapper {
	position: relative;
}
.vc-table {
	.vc-table__action {
		padding: 0.25em 8px 0.5em;
		text-align: center;
	}
	.vc-table__action-item {
		color: inherit;
		&.is-disabled {
			opacity: 0.4;
			cursor: not-allowed;
		}
		&.is-enabled {
			.vc-table__action-link:hover {
				filter: brightness(60%);
				box-shadow: 0 0 4px 2px rgba(0, 0, 0, 0.2);
			}
		}
	}
	.vc-table__action-link {
		display: inline-flex;
		align-items: center;
		justify-content: center;
		width: 32px;
		height: 32px;
		border-radius: 1em;
		transition: box-shadow 0.15s, filter 0.15s;

		color: inherit;
	}

	/deep/ .vc-table__row {
		&.is-clickable {
			cursor: pointer;
			position: relative;
			transform: translateZ(0);
			a {
				position: relative;
				z-index: 10;
			}
		}

		.vc-table__null-cell {
			display: block;
			width: 0;
			padding: 0;
			overflow: hidden;
			margin: 0;
		}

		.vc-table__row-link {
			position: absolute !important;
			z-index: 0 !important;
			top: 0;
			left: 0;
			right: 0;
			bottom: 0;
		}
	}
}
</style>
